Subject: Re: linux-next: build failure after merge of the akpm-current tree

From: [email-masked]
Date: Mon, 27 Jul 2015 13:31:10 -0700

On Mon, Jul 27, 2015 at 01:20:02PM -0700, Davidlohr Bueso wrote:
> On Mon, 2015-07-27 at 13:03 -0700, Andrew Morton wrote:
> > On Sat, 25 Jul 2015 15:35:24 -0700 Josh Triplett <[email-masked]> wrote:
> > 
> > > > Some mm functionality might very possibly rely on srcu in the future if
> > > > we expect any chances of scaling, ie: faults. So I'd rather not take a
> > > > short term solution here, as we'll probably be discussing this again
> > > > otherwise.
> > > 
> > > What other mm functionality plans to use SRCU?
> 
> Right now I have (unpublished) patches that use srcu as a way to avoid
> mmap_sem when faulting across the entire path. Previous alternatives
> also use it, as ie, can involve IO and lots of other sleeping
> operations.

That sounds interesting!  mmap_sem is definitely a performance
bottleneck.  How do you handle writes versus reads?

> Yes, you can argue that they're not published all you want,
> but I'm talking beyond my specific use case. Linux VM is known to scale,
> why should we hide a core scalability tool from it?

In the case of mmap_sem, does it help at all if tiny kernels were 1)
non-preemptible and 2) non-SMP?  Tiny kernels don't necessarily care
about scaling.

> > > Among other things, no-mmu builds might still be able to omit it.
> > 
> > Yup.
> 
> Makes sense.

Thanks.

- Josh Triplett